<script setup lang="ts">
import { useI18n } from "vue-i18n";
import { useTheme } from "vuetify";

const config = useRuntimeConfig();
const t = useI18n();

const appID = config.public.oidcClientID;

const theme = useTheme();
const themeSelected = ref("light");
const languageSelected = ref("en");
const userParams = ref({});

useAPIFetch(`/api/applications/${appID}/userparams`).then((response) => {
  if ("params" in response.data.value) {
    userParams.value = response.data.value.params;

    if ("theme" in response.data.value.params) {
      themeSelected.value = response.data.value.params.theme;
    } else {
      themeSelected.value = "light";
      userParams.value.theme = "light";
    }

    if ("language" in response.data.value.params) {
      languageSelected.value = response.data.value.params.language;
    } else {
      languageSelected.value = "en";
      userParams.value.language = "en";
    }
  } else {
    userParams.value = response.data.value;
    userParams.value.theme = "light";
    userParams.value.language = "en";
  }
});

function toggleTheme() {
  userParams.value.theme = themeSelected.value;

  useAPIFetch(`/api/applications/${appID}/userparams`, {
    method: "PUT",
    body: { params: userParams.value },
  }).then((res) => {
    const error = res.error.value;
    if (error) {
      userParams.value.theme = theme.global.name.value;
      themeSelected.value = theme.global.name.value;
      // throw createError({ statusCode: 400, statusMessage: "Exception API", data: error.data });
    } else {
      theme.global.name.value = themeSelected.value;
    }
  });
}

function toggleLanguage() {
  userParams.value.language = languageSelected.value;
  useAPIFetch(`/api/applications/${appID}/userparams`, {
    method: "PUT",
    body: { params: userParams.value },
  }).then((res) => {
    const error = res.error.value;
    if (error) {
      userParams.value.language = t.locale.value;
      languageSelected.value = t.locale.value;
      // throw createError({ statusCode: 400, statusMessage: "Exception API", data: error.data });
    } else {
      t.locale.value = languageSelected.value;
    }
  });
}
</script>

<template>
  <div class="pa-4">
    <v-sheet class="me-auto" style="overflow: hidden; white-space: nowrap; text-overflow: ellipsis">
      <h1>{{ $t("my_parameters") }}</h1>
    </v-sheet>
    <hr class="mb-3">
    <h3>{{ $t("appearance_title") }}</h3>
    <v-sheet class="d-flex align-center">
      <v-sheet class="me-auto pe-4 text-justify">
        {{ $t("appearance_description") }}
      </v-sheet>
      <v-sheet>
        <v-select
          v-model="themeSelected"
          :items="['light', 'dark']"
          variant="underlined"
          @update:modelValue="toggleTheme()"
        />
      </v-sheet>
    </v-sheet>
    <h3>{{ $t("language") }}</h3>
    <v-sheet class="d-flex align-center">
      <v-sheet class="me-auto pe-4 text-justify">
        {{ $t("language_description") }}
      </v-sheet>
      <v-sheet>
        <v-select
          v-model="languageSelected"
          :items="['fr', 'en']"
          variant="underlined"
          @update:modelValue="toggleLanguage()"
        />
      </v-sheet>
    </v-sheet>
  </div>
</template>

<style></style>
